precision mediump float;//给出默认的浮点精度
varying vec2 vTextureCoord;//从顶点着色器传递过来的纹理坐标
uniform sampler2D sTexture;//纹理内容数据

uniform mat3 uDataMatrix1; //矩阵1
uniform mat4 uDataMatrix2; //矩阵2
uniform int type; //矩阵维数。

//for future jni
// 1.0 / sqrt(2.0 * M_PI * pow(sigma, 2.0))) * exp(-pow(currentGaussianWeightIndex, 2.0) / (2.0 * pow(sigma, 2.0))

//高斯模板(7*7)，sigma = 0.84089642，归一化后得到
//float kernel11[121];
//float kernel7[49] = float[49](0.00000067, 0.00002292, 0.00019117, 0.00038771, 0.00019117, 0.00002292, 0.00000067,    0.00002292, 0.00078633, 0.00655965, 0.01330373, 0.00655965, 0.00078633, 0.00002292,    0.00019117, 0.00655965, 0.05472157, 0.11098164, 0.05472157, 0.00655965, 0.00019117,    0.00038771, 0.01330373, 0.11098164, 0.22508352, 0.11098164, 0.01330373, 0.00038771,    0.00019117, 0.00655965, 0.05472157, 0.11098164, 0.05472157, 0.00655965, 0.00019117,    0.00002292, 0.00078633, 0.00655965, 0.01330373, 0.00655965, 0.00078633, 0.00002292,    0.00000067, 0.00002292, 0.00019117, 0.00038771, 0.00019117, 0.00002292, 0.00000067);
//float kernel3[9] = float[9](0.0074106897, 0.071263984, 0.0074106897, 0.071263984, 0.6853013, 0.071263984, 0.0074106897, 0.071263984, 0.0074106897);

float kernel3[9] = float[9](1.0, 1.0,1.0, 1.0, 1.0,  1.0, 1.0, 1.0,1.0);
//浮雕
//float kernel3[9] = float[9](0.0, 1.0, 0.0, 1.0, -4.0,  1.0, 0.0, 1.0, 0.0);
float getKernelValue(int columnIndex,int rowIndex) {
    if (type==7){
    //       return kernel7[columnIndex*type+rowIndex];
    } else if (type==3){
         return kernel3[columnIndex*type+rowIndex];
    } else if (type==11){
       //  return kernel11[columnIndex*type+rowIndex];
    }
//    return uDataMatrix1[columnIndex][rowIndex];
}
vec4 getTargetColorValue(int columnIndex,int rowIndex) {
    vec4 cTemp0;
    int centerIndex = type/2;
     vec2 offset0=vec2(columnIndex-centerIndex,rowIndex-centerIndex);
   //  offset0=vec2(0.0,0.0);
   offset0.x /= 260.0;
   offset0.y /= 440.0;
 
  // offset0.x /= 720.0;
 //  offset0.y /= 1280.0;
     cTemp0=texture2D(sTexture, vTextureCoord.st + offset0);
     return cTemp0;
}

void main() {           
    //给出卷积内核中各个元素对应像素相对于待处理像素的纹理坐标偏移量
    vec2 offset0=vec2(-1.0,-1.0); vec2 offset1=vec2(0.0,-1.0); vec2 offset2=vec2(1.0,-1.0);
    vec2 offset3=vec2(-1.0,0.0); vec2 offset4=vec2(0.0,0.0); vec2 offset5=vec2(1.0,0.0);
    vec2 offset6=vec2(-1.0,1.0); vec2 offset7=vec2(0.0,1.0); vec2 offset8=vec2(1.0,1.0); 
    const float scaleFactor = 1.0/8.0;//给出最终求和时的加权因子(为调整亮度)
  //  const float scaleFactor = 1.0/9.0;//给出最终求和时的加权因子(为调整亮度)
    //卷积内核中各个位置的值
    float kernelValue0 = 1.0; float kernelValue1 = 1.0; float kernelValue2 = 1.0;
    float kernelValue3 = 1.0; float kernelValue4 = 1.0; float kernelValue5 = 1.0;
    float kernelValue6 = 1.0; float kernelValue7 = 1.0; float kernelValue8 = 1.0;
    vec4 sum;//最终的颜色和
    //获取卷积内核中各个元素对应像素的颜色值
 //   vec4 cTemp0,cTemp1,cTemp2,cTemp3,cTemp4,cTemp5,cTemp6,cTemp7,cTemp8;    
 //   cTemp0=texture2D(sTexture, vTextureCoord.st + offset0.xy/512.0);
  //  cTemp1=texture2D(sTexture, vTextureCoord.st + offset1.xy/512.0);
  //  cTemp2=texture2D(sTexture, vTextureCoord.st + offset2.xy/512.0);
  //  cTemp3=texture2D(sTexture, vTextureCoord.st + offset3.xy/512.0);
  //  cTemp4=texture2D(sTexture, vTextureCoord.st + offset4.xy/512.0);
 //   cTemp5=texture2D(sTexture, vTextureCoord.st + offset5.xy/512.0);
  //  cTemp6=texture2D(sTexture, vTextureCoord.st + offset6.xy/512.0);
  //  cTemp7=texture2D(sTexture, vTextureCoord.st + offset7.xy/512.0);
 //   cTemp8=texture2D(sTexture, vTextureCoord.st + offset8.xy/512.0);
    //颜色求和
  //  sum =kernelValue0*cTemp0+kernelValue1*cTemp1+kernelValue2*cTemp2+
 //        kernelValue3*cTemp3+kernelValue4*cTemp4+kernelValue5*cTemp5+
  //       kernelValue6*cTemp6+kernelValue7*cTemp7+kernelValue8*cTemp8; 
  //  gl_FragColor = sum * scaleFactor; //进行亮度加权后将最终颜色传递给管线
    
  //     kernel7 = float[49](
   //       0.00000067, 0.00002292, 0.00019117, 0.00038771, 0.00019117, 0.00002292, 0.00000067,    0.00002292, 0.00078633, 0.00655965, 0.01330373, 0.00655965, 0.00078633, 0.00002292,    0.00019117, 0.00655965, 0.05472157, 0.11098164, 0.05472157, 0.00655965, 0.00019117,    0.00038771, 0.01330373, 0.11098164, 0.22508352, 0.11098164, 0.01330373, 0.00038771,    0.00019117, 0.00655965, 0.05472157, 0.11098164, 0.05472157, 0.00655965, 0.00019117,    0.00002292, 0.00078633, 0.00655965, 0.01330373, 0.00655965, 0.00078633, 0.00002292,    0.00000067, 0.00002292, 0.00019117, 0.00038771, 0.00019117, 0.00002292, 0.00000067
   //   );
    //11阶勉强够用。.
   // kernel11 = float[121](
  //  3.5713972E-6, 2.0713163E-5, 8.128458E-5, 2.1583601E-4, 3.877871E-4, 4.7142917E-4, 3.877871E-4, 2.1583601E-4, 8.128458E-5, 2.0713163E-5, 3.5713972E-6, 2.0713163E-5, 1.2013083E-4, 4.7142917E-4, 0.0012517917, 0.0022490623, 0.0027341645, 0.0022490623, 0.0012517917, 4.7142917E-4, 1.2013083E-4, 2.0713163E-5, 8.128458E-5, 4.7142917E-4, 0.0018500283, 0.004912404, 0.00882599, 0.010729675, 0.00882599, 0.004912404, 0.0018500283, 4.7142917E-4, 8.128458E-5, 2.1583601E-4, 0.0012517917, 0.004912404, 0.013043967, 0.023435762, 0.028490642, 0.023435762, 0.013043967, 0.004912404, 0.0012517917, 2.1583601E-4, 3.877871E-4, 0.0022490623, 0.00882599, 0.023435762, 0.042106442, 0.05118841, 0.042106442, 0.023435762, 0.00882599, 0.0022490623, 3.877871E-4, 4.7142917E-4, 0.0027341645, 0.010729675, 0.028490642, 0.05118841, 0.062229283, 0.05118841, 0.028490642, 0.010729675, 0.0027341645, 4.7142917E-4, 3.877871E-4, 0.0022490623, 0.00882599, 0.023435762, 0.042106442, 0.05118841, 0.042106442, 0.023435762, 0.00882599, 0.0022490623, 3.877871E-4, 2.1583601E-4, 0.0012517917, 0.004912404, 0.013043967, 0.023435762, 0.028490642, 0.023435762, 0.013043967, 0.004912404, 0.0012517917, 2.1583601E-4, 8.128458E-5, 4.7142917E-4, 0.0018500283, 0.004912404, 0.00882599, 0.010729675, 0.00882599, 0.004912404, 0.0018500283, 4.7142917E-4, 8.128458E-5, 2.0713163E-5, 1.2013083E-4, 4.7142917E-4, 0.0012517917, 0.0022490623, 0.0027341645, 0.0022490623, 0.0012517917, 4.7142917E-4, 1.2013083E-4, 2.0713163E-5, 3.5713972E-6, 2.0713163E-5, 8.128458E-5, 2.1583601E-4, 3.877871E-4, 4.7142917E-4, 3.877871E-4, 2.1583601E-4, 8.128458E-5, 2.0713163E-5, 3.5713972E-6
  //  );
    //03-31 18:32:04.163: E/ES20_ERROR(22399): ERROR: 0:65: 'assign' :  cannot convert from 'const array of float' to 'array of float'
    
    
    int columnSize = type;
    int rowSize = type;
     for (int j = 0;j<rowSize;j++) {
       for (int i = 0;i<columnSize;i++) {
            sum +=getKernelValue(i,j)*getTargetColorValue(i,j);
       }
     }
     gl_FragColor = sum * scaleFactor; //进行亮度加权后将最终颜色传递给管线
}         
